'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _graphql = require('graphql');

var _language = require('graphql/language');

var GraphQLLowercaseString = new _graphql.GraphQLScalarType({
  name: 'LowercaseString',
  description: 'The `LowercaseString` scalar type returns all strings in lower case',
  serialize: function serialize(value) {
    return value.toLowerCase();
  },
  parseValue: function parseValue(value) {
    return value.toLowerCase();
  },
  parseLiteral: function parseLiteral(ast) {
    if (ast.kind === _language.Kind.STRING) {
      return ast.value.toLowerCase();
    }

    return undefined;
  }
});

exports.default = GraphQLLowercaseString;